/* Generated automatically by the program `genoutput'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "flags.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "memmodel.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "tm_p.h"
#include "regs.h"
#include "conditions.h"
#include "insn-attr.h"

#include "recog.h"

#include "diagnostic-core.h"
#include "output.h"
#include "target.h"
#include "tm-constrs.h"

static const char *
output_7 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 168 "../../../gcc/gcc/config/msp430/msp430.md"

    if (TARGET_LARGE)
      return "SUBA\t#2, r1 { MOVX.A\t2(r1), 0(r1)";
    return "SUB\t#2, r1 { MOV.W\t2(r1), 0(r1)";
  
}

static const char *
output_8 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 178 "../../../gcc/gcc/config/msp430/msp430.md"
 return TARGET_LARGE
	   ? "MOVX.A\t0(r1), 2(r1) { ADDA\t#2, SP"
	   : "MOV.W\t0(r1), 2(r1) { ADD\t#2, SP";
  
}

static const char * const output_9[] = {
  "MOV.B\t%1, %0",
  "MOV%X1.B\t%1, %0",
};

static const char * const output_10[] = {
  "MOV.B\t%1, %0",
  "MOV%X1.B\t%1, %0",
};

static const char *
output_12 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "MOV.B\t%1, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	    "MOV.B\t%1, %0" : 	    "MOVX.B\t%1, %0");
      default: gcc_unreachable ();
    }
}

static const char * const output_13[] = {
  "MOV.B\t%1, %0",
  "MOV%X1.B\t%1, %0",
};

static const char *
output_14 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "MOV.B\t%1, %0";
    case 1: return "MOV.W\t%1, %0";
    case 2:
       return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	    "MOV.W\t%1, %0" : 	    "MOVX.W\t%1, %0");
      default: gcc_unreachable ();
    }
}

static const char * const output_17[] = {
  "MOV.B\t%1, %0",
  "MOV.W\t%1, %0",
  "MOVA\t%1, %0",
  "MOVA\t%1, %0",
  "MOVX.A\t%1, %0",
};

static const char * const output_20[] = {
  "ADDA\t%2, %0",
  "ADDX.A\t%2, %0",
};

static const char *
output_21 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "ADD.B\t%2, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "ADD.B\t%2, %0" : 	     "ADDX.B\t%2, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_22 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "ADD.W\t%2, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "ADD.W\t%2, %0" : 	     "ADDX.W\t%2, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_24 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "ADD\t%L2, %L0 { ADDC\t%H2, %H0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "ADD\t%L2, %L0 { ADDC\t%H2, %H0" : 	     "ADDX\t%L2, %L0 { ADDCX\t%H2, %H0");
      default: gcc_unreachable ();
    }
}

static const char *
output_25 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "ADD\t%2, %1 ; cy";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "ADD\t%2, %1 ; cy" : 	     "ADDX\t%2, %1 ; cy");
      default: gcc_unreachable ();
    }
}

static const char * const output_26[] = {
  "ADD\t%2, %1 ; cy",
  "ADD%X0\t%2, %1 ; cy",
};

static const char *
output_27 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "ADDC\t%2, %1";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "ADDC\t%2, %1" : 	     "ADDCX\t%2, %1");
      default: gcc_unreachable ();
    }
}

static const char * const output_28[] = {
  "SUBA\t%2, %0",
  "SUBX.A\t%2, %0",
  "MOVX.A\t%1, %0 { SUBX.A\t%2, %0",
  "MOVX.A\t%1, %0 { SUBA\t%2, %0",
};

static const char *
output_29 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "SUB.B\t%2, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "SUB.B\t%2, %0" : 	     "SUBX.B\t%2, %0");
    case 2: return "MOV%X2.B\t%1, %0 { SUB%X2.B\t%2, %0";
    case 3: return "MOV%X0.B\t%1, %0 { SUB%X0.B\t%2, %0";
      default: gcc_unreachable ();
    }
}

static const char *
output_30 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "SUB.W\t%2, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	    "SUB.W\t%2, %0" : 	    "SUBX.W\t%2, %0");
    case 2: return "MOV%X2.W\t%1, %0 { SUB%X2.W\t%2, %0";
    case 3: return "MOV%X0.W\t%1, %0 { SUB%X0.W\t%2, %0";
      default: gcc_unreachable ();
    }
}

static const char *
output_31 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 530 "../../../gcc/gcc/config/msp430/msp430.md"

  return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	  "SUB\t%L2, %L0 { SUBC\t%H2, %H0" : 	  "SUBX\t%L2, %L0 { SUBCX\t%H2, %H0");
}

static const char * const output_32[] = {
  "BIC%x0%b0\t#%I2, %0",
  "BIC%X0%b0\t#%I2, %0",
};

static const char * const output_33[] = {
  "BIC%x0%b0\t#%I2, %0",
  "BIC%X0%b0\t#%I2, %0",
};

static const char * const output_34[] = {
  "BIC%x0%b0\t#%I2, %0",
  "BIC%X0%b0\t#%I2, %0",
};

static const char *
output_35 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "BIC%x0%b0\t%1, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	     "BIC%b0\t%1, %0" : 	     "BICX%b0\t%1, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_36 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "BIC%x0%b0\t%1, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	     "BIC%b0\t%1, %0" : 	     "BICX%b0\t%1, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_37 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "BIC%x0%b0\t%1, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	     "BIC%b0\t%1, %0" : 	     "BICX%b0\t%1, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_38 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "AND%x0.B\t%2, %0";
    case 1: return "AND%x0%b0\t%2, %0";
    case 2:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "AND%b0\t%2, %0" : 	     "ANDX%b0\t%2, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_39 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "AND%x0.B\t%2, %0";
    case 1: return "AND%x0%b0\t%2, %0";
    case 2:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "AND%b0\t%2, %0" : 	     "ANDX%b0\t%2, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_40 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "AND%x0.B\t%2, %0";
    case 1: return "AND%x0%b0\t%2, %0";
    case 2:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "AND%b0\t%2, %0" : 	     "ANDX%b0\t%2, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_41 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "BIS%x0%b0\t%2, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "BIS%b0\t%2, %0" : 	     "BISX%b0\t%2, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_42 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "BIS%x0%b0\t%2, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "BIS%b0\t%2, %0" : 	     "BISX%b0\t%2, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_43 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "BIS%x0%b0\t%2, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "BIS%b0\t%2, %0" : 	     "BISX%b0\t%2, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_44 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "XOR%x0%b0\t%2, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "XOR%b0\t%2, %0" : 	     "XORX%b0\t%2, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_45 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "XOR%x0%b0\t%2, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "XOR%b0\t%2, %0" : 	     "XORX%b0\t%2, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_46 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "XOR%x0%b0\t%2, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "XOR%b0\t%2, %0" : 	     "XORX%b0\t%2, %0");
      default: gcc_unreachable ();
    }
}

static const char * const output_47[] = {
  "INV%x0%b0\t%0",
  "INV%X0%b0\t%0",
};

static const char * const output_48[] = {
  "INV%x0%b0\t%0",
  "INV%X0%b0\t%0",
};

static const char * const output_49[] = {
  "INV%x0%b0\t%0",
  "INV%X0%b0\t%0",
};

static const char * const output_50[] = {
  "SXT%X0\t%0",
  "SXT%X0\t%0",
};

static const char * const output_51[] = {
  "AND\t#0xff, %0",
  "MOV.B\t%1, %0",
  "MOV%X1.B\t%1, %0",
  "AND%X0\t#0xff, %0",
};

static const char * const output_52[] = {
  "MOV.B\t%1, %0",
  "MOV%X1.B\t%1, %0",
};

static const char * const output_53[] = {
  "CLR\t%H0",
  "MOV%X1.B\t%1,%L0 { CLR\t%H0",
};

static const char * const output_54[] = {
  "MOV.W\t%1, %0",
  "MOV%X1\t%1, %0",
  "MOVX.A\t%1, %0",
};

static const char *
output_55 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0:
       return (msp430_430x_insn_not_required (operands[0], operands[1]) ?     "MOV.W\t#0,%H0" :     "MOVX.W\t#0,%H0");
    case 1: return "MOV.W\t%1,%L0 { MOV.W\t#0,%H0";
      default: gcc_unreachable ();
    }
}

static const char * const output_56[] = {
  "AND.W\t#-1,%0",
  "MOV.W\t%1,%0",
};

static const char *
output_57 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0:
       if (REGNO (operands[1]) == SP_REGNO)       /* If the source register is the stack pointer, the value          stored in the stack slot will be the value *after* the 	 stack pointer has been decremented.  So allow for that 	 here.  */       return "PUSHM.A\t#1, %1 { ADDX.W\t#4, @r1 { POPX.W\t%L0 { POPX.W\t%H0 ; get stack pointer into %L0:%H0";     else       return "PUSHM.A\t#1, %1 { POPX.W\t%L0 { POPX.W\t%H0 ; move pointer in %1 into reg-pair %L0:%H0";
    case 1: return "MOVX.A %1, %0";
      default: gcc_unreachable ();
    }
}

static const char *
output_65 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 837 "../../../gcc/gcc/config/msp430/msp430.md"
{ return msp430x_extendhisi (operands); }
}

static const char *
output_69 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 876 "../../../gcc/gcc/config/msp430/msp430.md"

    /* The intention here is that we copy the bottom 16-bits of
       %1 into %L0 (zeroing the top four bits).  Then we copy the
       entire 20-bits of %1 into %H0 and then arithmetically shift
       it right by 16 bits, to get the top four bits of the pointer
       sign-extended in %H0.  */
    if (REGNO (operands[0]) == REGNO (operands[1]))
      return "MOVX.A\t%1, %H0 { MOV.W\t%1, %L0 { RPT\t#16 { RRAX.A\t%H0 ; sign extend pointer in %1 into %L0:%H0";
    else
      return "MOV.W\t%1, %L0 { MOVX.A\t%1, %H0 { RPT\t#16 { RRAX.A\t%H0 ; sign extend pointer in %1 into %L0:%H0";
  
}

static const char *
output_71 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 946 "../../../gcc/gcc/config/msp430/msp430.md"
 return msp430_output_asm_shift_insns (ASHIFT, HImode, operands);
}

static const char *
output_72 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 946 "../../../gcc/gcc/config/msp430/msp430.md"
 return msp430_output_asm_shift_insns (ASHIFTRT, HImode, operands);
}

static const char *
output_73 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 946 "../../../gcc/gcc/config/msp430/msp430.md"
 return msp430_output_asm_shift_insns (LSHIFTRT, HImode, operands);
}

static const char *
output_74 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 955 "../../../gcc/gcc/config/msp430/msp430.md"
 return msp430_output_asm_shift_insns (ASHIFT, SImode, operands);
}

static const char *
output_75 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 955 "../../../gcc/gcc/config/msp430/msp430.md"
 return msp430_output_asm_shift_insns (ASHIFTRT, SImode, operands);
}

static const char *
output_76 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 955 "../../../gcc/gcc/config/msp430/msp430.md"
 return msp430_output_asm_shift_insns (LSHIFTRT, SImode, operands);
}

static const char * const output_77[] = {
  "RLAM%b0\t%2, %0",
  "RPT\t%2 { RLAX%b0\t%0",
  "RPT\t#16 { RLAX%b0\t%0 { RPT\t%W2 { RLAX%b0\t%0",
  "# undefined behavior left shift of %1 by %2",
};

static const char * const output_78[] = {
  "RLAM%b0\t%2, %0",
  "RPT\t%2 { RLAX%b0\t%0",
  "RPT\t#16 { RLAX%b0\t%0 { RPT\t%W2 { RLAX%b0\t%0",
  "# undefined behavior left shift of %1 by %2",
};

static const char * const output_79[] = {
  "RRAM%b0\t%2, %0",
  "RPT\t%2 { RRAX%b0\t%0",
  "RPT\t#16 { RRAX%b0\t%0 { RPT\t%W2 { RRAX%b0\t%0",
  "# undefined behavior arithmetic right shift of %1 by %2",
};

static const char * const output_80[] = {
  "RRAM%b0\t%2, %0",
  "RPT\t%2 { RRAX%b0\t%0",
  "RPT\t#16 { RRAX%b0\t%0 { RPT\t%W2 { RRAX%b0\t%0",
  "# undefined behavior arithmetic right shift of %1 by %2",
};

static const char * const output_81[] = {
  "RRUM%b0\t%2, %0",
  "RPT\t%2 { RRUX%b0\t%0",
  "RPT\t#16 { RRUX%b0\t%0 { RPT\t%W2 { RRUX%b0\t%0",
  "# undefined behavior logical right shift of %1 by %2",
};

static const char * const output_82[] = {
  "RRUM%b0\t%2, %0",
  "RPT\t%2 { RRUX%b0\t%0",
  "RPT\t#16 { RRUX%b0\t%0 { RPT\t%W2 { RRUX%b0\t%0",
  "# undefined behavior logical right shift of %1 by %2",
};

static const char *
output_90 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1097 "../../../gcc/gcc/config/msp430/msp430.md"
{ return msp430_is_interrupt_func () ? "RETI" : (TARGET_LARGE ? "RETA" : "RET"); }
}

static const char * const output_95[] = {
  "CMP%Q0\t%2, %1 { J%0\t%l3",
  "CMPX.A\t%2, %1 { J%0\t%l3",
  "CMPX.A\t%2, %1 { J%0\t%l3",
};

static const char *
output_96 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "CMP.B\t%2, %1 { J%0\t%l3";
    case 1:
       return (msp430_430x_insn_not_required (operands[1], operands[2]) ? 	     "CMP.B\t%2, %1 { J%0\t%l3" : 	     "CMPX.B\t%2, %1 { J%0\t%l3");
      default: gcc_unreachable ();
    }
}

static const char *
output_97 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1217 "../../../gcc/gcc/config/msp430/msp430.md"

    /* This is nasty.  If we are splitting code between low and high memory
       then we do not want the linker to increase the size of sections by
       relaxing out of range jump instructions.  (Since relaxation occurs
       after section placement).  So we have to generate pessimal branches
       here.  But we only want to do this when really necessary.

       FIXME: Do we need code in the other cbranch patterns ?  */
    if (msp430_do_not_relax_short_jumps () && get_attr_length (insn) > 6)
      {
        return which_alternative == 0 ?
            "CMP.W\t%2, %1 { J%r0 1f { BRA #%l3 { 1:" :
	    (msp430_430x_insn_not_required (operands[1], operands[2]) ?
	     "CMP.W\t%2, %1 { J%r0 1f { BRA #%l3 { 1:" :
	     "CMPX.W\t%2, %1 { J%r0 1f { BRA #%l3 { 1:");
      }

    return which_alternative == 0 ?
         "CMP.W\t%2, %1 { J%0\t%l3" :
	 (msp430_430x_insn_not_required (operands[1], operands[2]) ?
	  "CMP.W\t%2, %1 { J%0\t%l3" :
	  "CMPX.W\t%2, %1 { J%0\t%l3");
  
}

static const char * const output_98[] = {
  "CMP%Q0\t%1, %2 { J%R0\t%l3",
  "CMPX.A\t%1, %2 { J%R0\t%l3",
  "CMPX.A\t%1, %2 { J%R0\t%l3",
};

static const char *
output_99 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "CMP.B\t%1, %2 { J%R0\t%l3";
    case 1:
       return (msp430_430x_insn_not_required (operands[1], operands[2]) ? 	     "CMP.B\t%1, %2 { J%R0\t%l3" : 	     "CMPX.B\t%1, %2 { J%R0\t%l3");
      default: gcc_unreachable ();
    }
}

static const char *
output_100 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "CMP.W\t%1, %2 { J%R0\t%l3";
    case 1:
       return (msp430_430x_insn_not_required (operands[1], operands[2]) ? 	     "CMP.W\t%1, %2 { J%R0\t%l3" : 	     "CMPX.W\t%1, %2 { J%R0\t%l3");
      default: gcc_unreachable ();
    }
}

static const char *
output_101 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "BIT%x0%b0\t%1, %0 { JNE\t%l2";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	     "BIT%b0\t%1, %0 { JNE\t%l2" : 	     "BITX%b0\t%1, %0 { JNE\t%l2");
      default: gcc_unreachable ();
    }
}

static const char *
output_102 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "BIT%x0%b0\t%1, %0 { JNE\t%l2";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	     "BIT%b0\t%1, %0 { JNE\t%l2" : 	     "BITX%b0\t%1, %0 { JNE\t%l2");
      default: gcc_unreachable ();
    }
}

static const char *
output_103 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "BIT%x0%b0\t%1, %0 { JNE\t%l2";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	     "BIT%b0\t%1, %0 { JNE\t%l2" : 	     "BITX%b0\t%1, %0 { JNE\t%l2");
      default: gcc_unreachable ();
    }
}

static const char *
output_104 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1326 "../../../gcc/gcc/config/msp430/msp430.md"

   return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	     "BIT%b0\t%1, %0 { JEQ\t%l2" : 	     "BITX%b0\t%1, %0 { JEQ\t%l2");
}

static const char *
output_105 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1326 "../../../gcc/gcc/config/msp430/msp430.md"

   return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	     "BIT%b0\t%1, %0 { JEQ\t%l2" : 	     "BITX%b0\t%1, %0 { JEQ\t%l2");
}

static const char *
output_106 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1326 "../../../gcc/gcc/config/msp430/msp430.md"

   return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	     "BIT%b0\t%1, %0 { JEQ\t%l2" : 	     "BITX%b0\t%1, %0 { JEQ\t%l2");
}

static const char *
output_107 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1342 "../../../gcc/gcc/config/msp430/msp430.md"

  return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	  "BIT%b0\t%1, %0 { JNE\t%l2" : 	  "BITX%b0\t%1, %0 { JNE\t%l2");
}

static const char *
output_108 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1342 "../../../gcc/gcc/config/msp430/msp430.md"

  return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	  "BIT%b0\t%1, %0 { JNE\t%l2" : 	  "BITX%b0\t%1, %0 { JNE\t%l2");
}

static const char *
output_109 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1342 "../../../gcc/gcc/config/msp430/msp430.md"

  return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	  "BIT%b0\t%1, %0 { JNE\t%l2" : 	  "BITX%b0\t%1, %0 { JNE\t%l2");
}

static const char *
output_110 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1358 "../../../gcc/gcc/config/msp430/msp430.md"

  return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	  "BIT%b0\t%1, %0 { JEQ\t%l2" : 	  "BITX%b0\t%1, %0 { JEQ\t%l2");
}

static const char *
output_111 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1358 "../../../gcc/gcc/config/msp430/msp430.md"

  return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	  "BIT%b0\t%1, %0 { JEQ\t%l2" : 	  "BITX%b0\t%1, %0 { JEQ\t%l2");
}

static const char *
output_112 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1358 "../../../gcc/gcc/config/msp430/msp430.md"

  return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	  "BIT%b0\t%1, %0 { JEQ\t%l2" : 	  "BITX%b0\t%1, %0 { JEQ\t%l2");
}

static const char * const output_113[] = {
  "BIT%x0%b0\t%p1, %0 { JNE\t%l2",
  "BIT%X0%b0\t%p1, %0 { JNE\t%l2",
};

static const char * const output_114[] = {
  "BIT%x0%b0\t%p1, %0 { JNE\t%l2",
  "BIT%X0%b0\t%p1, %0 { JNE\t%l2",
};

static const char * const output_115[] = {
  "BIT%x0%b0\t%p1, %0 { JNE\t%l2",
  "BIT%X0%b0\t%p1, %0 { JNE\t%l2",
};

static const char *
output_132 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1482 "../../../gcc/gcc/config/msp430/msp430.md"

    if (REGNO (operands[0]) != REGNO (operands[1]))
      return "MOV.W\t%1, %0 { INV.W\t%0 { INC.W\t%0 { AND.W\t%2, %0";
    else
      return "INV.W\t%0 { INC.W\t%0 { AND.W\t%2, %0";
  
}

static const char *
output_141 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1620 "../../../gcc/gcc/config/msp430/msp430.md"

    if (msp430_use_f5_series_hwmult ())
      return "PUSH.W sr { DINT { NOP { MOV.W %1, &0x04C2 { MOV.W %2, &0x04C8 { MOV.W &0x04CA, %L0 { MOV.W &0x04CC, %H0 { POP.W sr";
    else
      return "PUSH.W sr { DINT { NOP { MOV.W %1, &0x0132 { MOV.W %2, &0x0138 { MOV.W &0x013A, %L0 { MOV.W &0x013C, %H0 { POP.W sr";
  
}

static const char *
output_142 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1633 "../../../gcc/gcc/config/msp430/msp430.md"

    if (msp430_use_f5_series_hwmult ())
      return "PUSH.W sr { DINT { NOP { MOV.W %1, &0x04C0 { MOV.W %2, &0x04C8 { MOV.W &0x04CA, %L0 { MOV.W &0x04CC, %H0 { POP.W sr";
    else
      return "PUSH.W sr { DINT { NOP { MOV.W %1, &0x0130 { MOV.W %2, &0x0138 { MOV.W &0x013A, %L0 { MOV.W &0x013C, %H0 { POP.W sr";
  
}

static const char *
output_143 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1646 "../../../gcc/gcc/config/msp430/msp430.md"

    if (msp430_use_f5_series_hwmult ())
      return "PUSH.W sr { DINT { NOP { MOV.W %L1, &0x04D4 { MOV.W %H1, &0x04D6 { MOV.W %L2, &0x04E0 { MOV.W %H2, &0x04E2 { MOV.W &0x04E4, %A0 { MOV.W &0x04E6, %B0 { MOV.W &0x04E8, %C0 { MOV.W &0x04EA, %D0 { POP.W sr";
    else
      return "PUSH.W sr { DINT { NOP { MOV.W %L1, &0x0144 { MOV.W %H1, &0x0146 { MOV.W %L2, &0x0150 { MOV.W %H2, &0x0152 { MOV.W &0x0154, %A0 { MOV.W &0x0156, %B0 { MOV.W &0x0158, %C0 { MOV.W &0x015A, %D0 { POP.W sr";
  
}

static const char *
output_144 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1659 "../../../gcc/gcc/config/msp430/msp430.md"

    if (msp430_use_f5_series_hwmult ())
      return "PUSH.W sr { DINT { NOP { MOV.W %L1, &0x04D0 { MOV.W %H1, &0x04D2 { MOV.W %L2, &0x04E0 { MOV.W %H2, &0x04E2 { MOV.W &0x04E4, %A0 { MOV.W &0x04E6, %B0 { MOV.W &0x04E8, %C0 { MOV.W &0x04EA, %D0 { POP.W sr";
    else
      return "PUSH.W sr { DINT { NOP { MOV.W %L1, &0x0140 { MOV.W %H1, &0x0142 { MOV.W %L2, &0x0150 { MOV.W %H2, &0x0152 { MOV.W &0x0154, %A0 { MOV.W &0x0156, %B0 { MOV.W &0x0158, %C0 { MOV.W &0x015A, %D0 { POP.W sr";
  
}



static const struct insn_operand_data operand_data[] = 
{
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    0,
    0
  },
  {
    register_operand,
    "r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    immediate_operand,
    "n",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    immediate_operand,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    immediate_operand,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r,r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "Ys,m",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=r,r",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "rYs,m",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_operand,
    "=r",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "r",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_operand,
    "=rYs,rm",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "riYs,rmi",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_operand,
    "=r,rYs,rm",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "N,riYs,rmi",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_nonv_operand,
    "=rm",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_symbol_operand,
    "i",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_nonv_operand,
    "=rm",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "rmi",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_operand,
    "=r,r,r,Ya,rm",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "N,O,riYa,r,rmi",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=r",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_symbol_operand,
    "i",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_operand,
    "=r,rm",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "%0,0",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_operand,
    "rLs,rmi",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_operand,
    "=rYs,rm",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "%0,0",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_operand,
    "riYs,rmi",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_operand,
    "=rYs,rm",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "%0,0",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_operand,
    "riYs,rmi",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=&r",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "rmi",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_nonv_operand,
    "=&r,rm",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "%0,0",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "r,mi",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_operand,
    "=r,rm",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "%0,0",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_nonimmediate_operand,
    "r,rm",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_nonimmediate_operand,
    "r,rm",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_nonv_operand,
    "=r,rm",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "%0,0",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    immediate_operand,
    "i,i",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    immediate_operand,
    "i,i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_operand,
    "=r,rm",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "%0,0",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_operand,
    "ri,rmi",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_nonv_operand,
    "=r,rm,&?r,?&r",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "0,0,!r,!i",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "rLs,rmi,rmi,r",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_nonv_operand,
    "=rYs,rm,&?r,?&r",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "0,0,!r,!i",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "riYs,rmi,rmi,r",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_nonv_operand,
    "=rYs,rm,&?r,?&r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "0,0,!r,!i",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "riYs,rmi,rmi,r",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_nonv_operand,
    "=&rm",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "rmi",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_operand,
    "=rYs,m",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "0,0",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_inv_constgen_operator,
    "n,n",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_operand,
    "=rYs,m",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "0,0",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_inv_constgen_operator,
    "n,n",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_operand,
    "=rYs,m",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "0,0",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_inv_constgen_operator,
    "n,n",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_operand,
    "=rYs,rm",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "rYs,rmn",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_operand,
    "0,0",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_operand,
    "=rYs,rm",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "rYs,rmn",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_operand,
    "0,0",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_operand,
    "=rYs,rm",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "rYs,rmn",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_operand,
    "0,0",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_operand,
    "=r,rYs,rm",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "%0,0,0",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_operand,
    "N,riYs,rmi",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_operand,
    "=r,rYs,rm",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "%0,0,0",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_operand,
    "N,riYs,rmi",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_operand,
    "=r,rYs,rm",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "%0,0,0",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_operand,
    "N,riYs,rmi",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_operand,
    "=rYs,rm",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "%0,0",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_operand,
    "riYs,rmi",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_operand,
    "=rYs,m",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "0,0",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_operand,
    "=rYs,r,r,m",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "0,rYs,m,0",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_nonv_operand,
    "=r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "0,rm",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_operand,
    "=r,r,m",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "rYs,m,r",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_nonv_operand,
    "=rm,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "0,r",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_nonv_operand,
    "=r,r",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "0,r",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "+r,m",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,r",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "rm",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_operand,
    "rm",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    immediate_operand,
    "M",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "rm",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    immediate_operand,
    "M",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "rm",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    immediate_operand,
    "M",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_operand,
    "=rm",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_nonv_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "r",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_nonv_operand,
    "=r",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "0",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_nonv_operand,
    "=rm",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "0",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    const_int_operand,
    "n",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_nonv_operand,
    "=rm",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    const_int_operand,
    "n",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_nonv_operand,
    "=r,r,r,r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "0,0,0,0",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    const_int_operand,
    "M,P,K,i",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_nonv_operand,
    "=r,r,r,r",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "0,0,0,0",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    const_int_operand,
    "M,P,K,i",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "rYci",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "rYci",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "rYl",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "r",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_cmp_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    nonimmediate_operand,
    "r,rYs,rm",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "rLs,rYsi,rmi",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_cmp_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    nonimmediate_operand,
    "rYs,rm",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "rYsi,rmi",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_cmp_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    nonimmediate_operand,
    "rYs,rm",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "rYsi,rmi",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_reversible_cmp_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    general_operand,
    "rLs,rYsi,rmi",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "r,rYs,rm",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_reversible_cmp_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    general_operand,
    "rYsi,rmi",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "rYs,rm",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_reversible_cmp_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    general_operand,
    "rYsi,rmi",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "rYs,rm",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_operand,
    "rYs,rm",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "rYsi,rmi",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_operand,
    "rYs,rm",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "rYsi,rmi",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_operand,
    "rYs,rm",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "rYsi,rmi",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_operand,
    "rm",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "rmi",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_operand,
    "rm",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "rmi",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_operand,
    "rm",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_operand,
    "rmi",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_operand,
    "rYs,rm",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    const_0_to_15_operand,
    "i,i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_operand,
    "rYs,rm",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    const_0_to_15_operand,
    "i,i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_operand,
    "rYs,rm",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    const_0_to_15_operand,
    "i,i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_operand,
    "rm",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    const_0_to_15_operand,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_operand,
    "rm",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    const_0_to_15_operand,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_operand,
    "rm",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    const_0_to_15_operand,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "ir",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    immediate_operand,
    "n",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%0",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_general_dst_nonv_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_nonv_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_nonv_operand,
    "",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_nonv_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_general_dst_nonv_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    nonimmediate_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    nonimmediate_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    nonimmediate_operand,
    "",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
};


#if GCC_VERSION >= 2007
__extension__
#endif

const struct insn_data_d insn_data[] = 
{
  /* <internal>:0 */
  {
    "*placeholder_for_nothing",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { 0 },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:95 */
  {
    "push",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "PUSH\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_push },
    &operand_data[1],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:102 */
  {
    "pusha",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "PUSHX.A\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_pusha },
    &operand_data[2],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:109 */
  {
    "pushm",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "PUSHM%b0\t%1, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_pushm },
    &operand_data[3],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:116 */
  {
    "pop",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "POP\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_pop },
    &operand_data[5],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:123 */
  {
    "popa",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "POPX.A\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_popa },
    &operand_data[6],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:141 */
  {
    "popm",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "POPM%b0\t%2, r%J1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_popm },
    &operand_data[7],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:165 */
  {
    "grow_and_swap",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_7 },
#else
    { 0, 0, output_7 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_grow_and_swap },
    &operand_data[0],
    0,
    0,
    0,
    0,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:175 */
  {
    "swap_and_shrink",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_8 },
#else
    { 0, 0, output_8 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_swap_and_shrink },
    &operand_data[0],
    0,
    0,
    0,
    0,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:187 */
  {
    "movqihi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_9 },
#else
    { 0, output_9, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movqihi },
    &operand_data[10],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:196 */
  {
    "movqipsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_10 },
#else
    { 0, output_10, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movqipsi },
    &operand_data[12],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:205 */
  {
    "movqi_topbyte",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "PUSHM.A\t#1,%1 { POPM.W\t#1,%0 { POPM.W\t#1,%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movqi_topbyte },
    &operand_data[14],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:212 */
  {
    "movqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_12 },
#else
    { 0, 0, output_12 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movqi },
    &operand_data[16],
    2,
    2,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:225 */
  {
    "*movqihipsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_13 },
#else
    { 0, output_13, 0 },
#endif
    { 0 },
    &operand_data[12],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:234 */
  {
    "movhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_14 },
#else
    { 0, 0, output_14 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movhi },
    &operand_data[18],
    2,
    2,
    0,
    3,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:253 */
  {
    "movsi_s",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi_s },
    &operand_data[20],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:266 */
  {
    "movsi_x",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi_x },
    &operand_data[22],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:280 */
  {
    "movpsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_17 },
#else
    { 0, output_17, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movpsi },
    &operand_data[24],
    2,
    2,
    0,
    5,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:298 */
  {
    "movsipsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "PUSH.W\t%H1 { PUSH.W\t%L1 { POPM.A #1, %0 ; Move reg-pair %L1:%H1 into pointer %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsipsi2 },
    &operand_data[26],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:306 */
  {
    "*movpsihi2_lo",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "MOVA\t%1, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[28],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:316 */
  {
    "addpsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_20 },
#else
    { 0, output_20, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addpsi3 },
    &operand_data[30],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:326 */
  {
    "addqi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_21 },
#else
    { 0, 0, output_21 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addqi3 },
    &operand_data[33],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:338 */
  {
    "addhi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_22 },
#else
    { 0, 0, output_22 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addhi3 },
    &operand_data[36],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:354 */
  {
    "addsipsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ADD%X2.W\t%L2, %L0 { ADDC%X2.W\t%H2, %H0 { PUSH.W\t%H0 { PUSH.W\t%L0 { POPM.A\t#1, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addsipsi3 },
    &operand_data[39],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:362 */
  {
    "addsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_24 },
#else
    { 0, 0, output_24 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addsi3 },
    &operand_data[42],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:404 */
  {
    "addhi3_cy",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_25 },
#else
    { 0, 0, output_25 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addhi3_cy },
    &operand_data[45],
    4,
    4,
    1,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:421 */
  {
    "addhi3_cy_i",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_26 },
#else
    { 0, output_26, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addhi3_cy_i },
    &operand_data[49],
    4,
    4,
    1,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:437 */
  {
    "addchi4_cy",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_27 },
#else
    { 0, 0, output_27 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addchi4_cy },
    &operand_data[53],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:483 */
  {
    "subpsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_28 },
#else
    { 0, output_28, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subpsi3 },
    &operand_data[56],
    3,
    3,
    0,
    4,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:496 */
  {
    "subqi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_29 },
#else
    { 0, 0, output_29 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subqi3 },
    &operand_data[59],
    3,
    3,
    0,
    4,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:511 */
  {
    "subhi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_30 },
#else
    { 0, 0, output_30 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subhi3 },
    &operand_data[62],
    3,
    3,
    0,
    4,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:525 */
  {
    "subsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_31 },
#else
    { 0, 0, output_31 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subsi3 },
    &operand_data[65],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:536 */
  {
    "*bicqi_cg",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_32 },
#else
    { 0, output_32, 0 },
#endif
    { 0 },
    &operand_data[68],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:536 */
  {
    "*bichi_cg",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_33 },
#else
    { 0, output_33, 0 },
#endif
    { 0 },
    &operand_data[71],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:536 */
  {
    "*bicpsi_cg",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_34 },
#else
    { 0, output_34, 0 },
#endif
    { 0 },
    &operand_data[74],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:546 */
  {
    "bicqi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_35 },
#else
    { 0, 0, output_35 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_bicqi3 },
    &operand_data[77],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:546 */
  {
    "bichi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_36 },
#else
    { 0, 0, output_36 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_bichi3 },
    &operand_data[80],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:546 */
  {
    "bicpsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_37 },
#else
    { 0, 0, output_37 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_bicpsi3 },
    &operand_data[83],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:558 */
  {
    "andqi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_38 },
#else
    { 0, 0, output_38 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_andqi3 },
    &operand_data[86],
    3,
    3,
    0,
    3,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:558 */
  {
    "andhi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_39 },
#else
    { 0, 0, output_39 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_andhi3 },
    &operand_data[89],
    3,
    3,
    0,
    3,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:558 */
  {
    "andpsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_40 },
#else
    { 0, 0, output_40 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_andpsi3 },
    &operand_data[92],
    3,
    3,
    0,
    3,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:571 */
  {
    "iorqi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_41 },
#else
    { 0, 0, output_41 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_iorqi3 },
    &operand_data[33],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:571 */
  {
    "iorhi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_42 },
#else
    { 0, 0, output_42 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_iorhi3 },
    &operand_data[36],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:571 */
  {
    "iorpsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_43 },
#else
    { 0, 0, output_43 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_iorpsi3 },
    &operand_data[95],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:583 */
  {
    "xorqi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_44 },
#else
    { 0, 0, output_44 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_xorqi3 },
    &operand_data[33],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:583 */
  {
    "xorhi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_45 },
#else
    { 0, 0, output_45 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_xorhi3 },
    &operand_data[36],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:583 */
  {
    "xorpsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_46 },
#else
    { 0, 0, output_46 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_xorpsi3 },
    &operand_data[95],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:596 */
  {
    "one_cmplqi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_47 },
#else
    { 0, output_47, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_one_cmplqi2 },
    &operand_data[68],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:596 */
  {
    "one_cmplhi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_48 },
#else
    { 0, output_48, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_one_cmplhi2 },
    &operand_data[71],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:596 */
  {
    "one_cmplpsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_49 },
#else
    { 0, output_49, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_one_cmplpsi2 },
    &operand_data[74],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:605 */
  {
    "extendqihi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_50 },
#else
    { 0, output_50, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendqihi2 },
    &operand_data[98],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:624 */
  {
    "zero_extendqihi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_51 },
#else
    { 0, output_51, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendqihi2 },
    &operand_data[100],
    2,
    2,
    0,
    4,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:635 */
  {
    "zero_extendqipsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_52 },
#else
    { 0, output_52, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendqipsi2 },
    &operand_data[12],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:646 */
  {
    "zero_extendqisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_53 },
#else
    { 0, output_53, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendqisi2 },
    &operand_data[102],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:655 */
  {
    "zero_extendhipsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_54 },
#else
    { 0, output_54, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendhipsi2 },
    &operand_data[104],
    2,
    2,
    0,
    3,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:665 */
  {
    "zero_extendhisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_55 },
#else
    { 0, 0, output_55 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendhisi2 },
    &operand_data[106],
    2,
    2,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:676 */
  {
    "zero_extendhisipsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_56 },
#else
    { 0, output_56, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendhisipsi2 },
    &operand_data[108],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:704 */
  {
    "zero_extendpsisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_57 },
#else
    { 0, 0, output_57 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendpsisi2 },
    &operand_data[110],
    2,
    2,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:745 */
  {
    "*msp430.md:745",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "MOV%X1.B\t%1, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[112],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:757 */
  {
    "*msp430.md:757",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "MOV%X1.B %1, %L0 { RLAM.W %2, %L0 { CLR %H0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[114],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:771 */
  {
    "*msp430.md:771",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "MOV%X1.B %1, %L0 { RLAM.W %2, %L0 { CLR %H0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[117],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:784 */
  {
    "*msp430.md:784",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "MOV%X1.B %1, %L0 { RLAM.W %2, %L0 { CLR %H0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[117],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:795 */
  {
    "*msp430.md:795",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "MOV%X1.B %1, %L0 { CLR %H0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[117],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:806 */
  {
    "*msp430.md:806",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "MOV%X1.B %1, %0 { RLAM.W %2, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[120],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:826 */
  {
    "truncpsihi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "MOVX\t%1, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_truncpsihi2 },
    &operand_data[123],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:833 */
  {
    "extendhisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_65 },
#else
    { 0, 0, output_65 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendhisi2 },
    &operand_data[125],
    2,
    2,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:840 */
  {
    "extendhipsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "RLAM.A #4, %0 { RRAM.A #4, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendhipsi2 },
    &operand_data[127],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:852 */
  {
    "extend_and_shift1_hipsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "RLAM.A #4, %0 { RRAM.A #3, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extend_and_shift1_hipsi2 },
    &operand_data[127],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:860 */
  {
    "extend_and_shift2_hipsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "RLAM.A #4, %0 { RRAM.A #2, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extend_and_shift2_hipsi2 },
    &operand_data[127],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:872 */
  {
    "extendpsisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_69 },
#else
    { 0, 0, output_69 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendpsisi2 },
    &operand_data[129],
    2,
    2,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:891 */
  {
    "truncsipsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "PUSH.W\t%H1 { PUSH.W\t%L1 { POPM.A\t#1, %L0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_truncsipsi2 },
    &operand_data[26],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:941 */
  {
    "aashlhi3_430",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_71 },
#else
    { 0, 0, output_71 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_aashlhi3_430 },
    &operand_data[131],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:941 */
  {
    "aashrhi3_430",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_72 },
#else
    { 0, 0, output_72 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_aashrhi3_430 },
    &operand_data[131],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:941 */
  {
    "alshrhi3_430",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_73 },
#else
    { 0, 0, output_73 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_alshrhi3_430 },
    &operand_data[131],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:950 */
  {
    "ashlsi3_const",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_74 },
#else
    { 0, 0, output_74 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashlsi3_const },
    &operand_data[134],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:950 */
  {
    "ashrsi3_const",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_75 },
#else
    { 0, 0, output_75 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashrsi3_const },
    &operand_data[134],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:950 */
  {
    "lshrsi3_const",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_76 },
#else
    { 0, 0, output_76 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_lshrsi3_const },
    &operand_data[134],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:959 */
  {
    "ashlhi3_430x",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_77 },
#else
    { 0, output_77, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashlhi3_430x },
    &operand_data[137],
    3,
    3,
    0,
    4,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:959 */
  {
    "ashlpsi3_430x",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_78 },
#else
    { 0, output_78, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashlpsi3_430x },
    &operand_data[140],
    3,
    3,
    0,
    4,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:975 */
  {
    "ashrhi3_430x",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_79 },
#else
    { 0, output_79, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashrhi3_430x },
    &operand_data[137],
    3,
    3,
    0,
    4,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:975 */
  {
    "ashrpsi3_430x",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_80 },
#else
    { 0, output_80, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashrpsi3_430x },
    &operand_data[140],
    3,
    3,
    0,
    4,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1000 */
  {
    "lshrhi3_430x",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_81 },
#else
    { 0, output_81, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_lshrhi3_430x },
    &operand_data[137],
    3,
    3,
    0,
    4,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1000 */
  {
    "lshrpsi3_430x",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_82 },
#else
    { 0, output_82, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_lshrpsi3_430x },
    &operand_data[140],
    3,
    3,
    0,
    4,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1027 */
  {
    "epilogue_helper",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BR%Q0\t#__mspabi_func_epilog_%J0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_epilogue_helper },
    &operand_data[8],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1035 */
  {
    "prologue_start_marker",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "; start of prologue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_prologue_start_marker },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1041 */
  {
    "prologue_end_marker",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "; end of prologue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_prologue_end_marker },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1047 */
  {
    "epilogue_start_marker",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "; start of epilogue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_epilogue_start_marker },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1055 */
  {
    "msp430_refsym_need_exit",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    ".refsym\t__crt0_call_exit",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_msp430_refsym_need_exit },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1071 */
  {
    "call_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "CALL%Q0\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_internal },
    &operand_data[143],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1086 */
  {
    "call_value_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "CALL%Q0\t%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_value_internal },
    &operand_data[145],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1094 */
  {
    "msp430_return",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_90 },
#else
    { 0, 0, output_90 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_msp430_return },
    &operand_data[0],
    0,
    0,
    0,
    0,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1116 */
  {
    "msp430_eh_epilogue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_msp430_eh_epilogue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1125 */
  {
    "jump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BR%Q0\t#%l0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_jump },
    &operand_data[144],
    1,
    1,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1134 */
  {
    "indirect_jump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BR%Q0\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_indirect_jump },
    &operand_data[148],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1149 */
  {
    "tablejump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BR%Q0\t%0 ; tablejump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tablejump },
    &operand_data[149],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1174 */
  {
    "cbranchpsi4_real",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_95 },
#else
    { 0, output_95, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchpsi4_real },
    &operand_data[151],
    4,
    4,
    0,
    3,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1190 */
  {
    "cbranchqi4_real",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_96 },
#else
    { 0, 0, output_96 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchqi4_real },
    &operand_data[155],
    4,
    4,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1207 */
  {
    "cbranchhi4_real",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_97 },
#else
    { 0, 0, output_97 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchhi4_real },
    &operand_data[159],
    4,
    4,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1249 */
  {
    "cbranchpsi4_reversed",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_98 },
#else
    { 0, output_98, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchpsi4_reversed },
    &operand_data[163],
    4,
    4,
    0,
    3,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1265 */
  {
    "cbranchqi4_reversed",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_99 },
#else
    { 0, 0, output_99 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchqi4_reversed },
    &operand_data[167],
    4,
    4,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1282 */
  {
    "cbranchhi4_reversed",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_100 },
#else
    { 0, 0, output_100 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchhi4_reversed },
    &operand_data[171],
    4,
    4,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1299 */
  {
    "*bitbranchqi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_101 },
#else
    { 0, 0, output_101 },
#endif
    { 0 },
    &operand_data[175],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1299 */
  {
    "*bitbranchhi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_102 },
#else
    { 0, 0, output_102 },
#endif
    { 0 },
    &operand_data[178],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1299 */
  {
    "*bitbranchpsi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_103 },
#else
    { 0, 0, output_103 },
#endif
    { 0 },
    &operand_data[181],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1316 */
  {
    "*bitbranchqi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_104 },
#else
    { 0, 0, output_104 },
#endif
    { 0 },
    &operand_data[184],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1316 */
  {
    "*bitbranchhi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_105 },
#else
    { 0, 0, output_105 },
#endif
    { 0 },
    &operand_data[187],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1316 */
  {
    "*bitbranchpsi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_106 },
#else
    { 0, 0, output_106 },
#endif
    { 0 },
    &operand_data[190],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1332 */
  {
    "*bitbranchqi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_107 },
#else
    { 0, 0, output_107 },
#endif
    { 0 },
    &operand_data[184],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1332 */
  {
    "*bitbranchhi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_108 },
#else
    { 0, 0, output_108 },
#endif
    { 0 },
    &operand_data[187],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1332 */
  {
    "*bitbranchpsi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_109 },
#else
    { 0, 0, output_109 },
#endif
    { 0 },
    &operand_data[190],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1348 */
  {
    "*bitbranchqi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_110 },
#else
    { 0, 0, output_110 },
#endif
    { 0 },
    &operand_data[184],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1348 */
  {
    "*bitbranchhi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_111 },
#else
    { 0, 0, output_111 },
#endif
    { 0 },
    &operand_data[187],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1348 */
  {
    "*bitbranchpsi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_112 },
#else
    { 0, 0, output_112 },
#endif
    { 0 },
    &operand_data[190],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1367 */
  {
    "*bitbranchqi4_z",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_113 },
#else
    { 0, output_113, 0 },
#endif
    { 0 },
    &operand_data[193],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1367 */
  {
    "*bitbranchhi4_z",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_114 },
#else
    { 0, output_114, 0 },
#endif
    { 0 },
    &operand_data[196],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1367 */
  {
    "*bitbranchpsi4_z",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_115 },
#else
    { 0, output_115, 0 },
#endif
    { 0 },
    &operand_data[199],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1383 */
  {
    "*bitbranchqi4_z",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BIT%X0%b0\t%p1, %0 { JEQ\t%l2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[202],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1383 */
  {
    "*bitbranchhi4_z",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BIT%X0%b0\t%p1, %0 { JEQ\t%l2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[205],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1383 */
  {
    "*bitbranchpsi4_z",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BIT%X0%b0\t%p1, %0 { JEQ\t%l2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[208],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1397 */
  {
    "*bitbranchqi4_z",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BIT%X0%b0\t%p1, %0 { JNE\t%l2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[202],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1397 */
  {
    "*bitbranchhi4_z",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BIT%X0%b0\t%p1, %0 { JNE\t%l2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[205],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1397 */
  {
    "*bitbranchpsi4_z",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BIT%X0%b0\t%p1, %0 { JNE\t%l2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[208],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1411 */
  {
    "*bitbranchqi4_z",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BIT%X0%b0\t%p1, %0 { JEQ\t%l2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[202],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1411 */
  {
    "*bitbranchhi4_z",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BIT%X0%b0\t%p1, %0 { JEQ\t%l2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[205],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1411 */
  {
    "*bitbranchpsi4_z",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BIT%X0%b0\t%p1, %0 { JEQ\t%l2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[208],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1428 */
  {
    "nop",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "NOP",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_nop },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1434 */
  {
    "disable_interrupts",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "DINT \n\t NOP",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_disable_interrupts },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1440 */
  {
    "enable_interrupts",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "EINT",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_enable_interrupts },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1446 */
  {
    "push_intr_state",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "PUSH\tSR",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_push_intr_state },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1452 */
  {
    "pop_intr_state",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "POP\tSR",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_pop_intr_state },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1460 */
  {
    "bic_SR",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BIC.W\t%0, %O0(SP)",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_bic_SR },
    &operand_data[211],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1468 */
  {
    "bis_SR",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BIS.W\t%0, %O0(SP)",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_bis_SR },
    &operand_data[211],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1477 */
  {
    "andneghi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_132 },
#else
    { 0, 0, output_132 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_andneghi3 },
    &operand_data[212],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1490 */
  {
    "delay_cycles_start",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "; Begin %J0 cycle delay",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_delay_cycles_start },
    &operand_data[8],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1497 */
  {
    "delay_cycles_end",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "; End %J0 cycle delay",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_delay_cycles_end },
    &operand_data[8],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1504 */
  {
    "delay_cycles_32",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "PUSH	r13\n\
	PUSH	r14\n\
	MOV.W	%A0, r13\n\
	MOV.W	%B0, r14\n\
1:	SUB.W	#1, r13\n\
	SUBC.W	#0, r14\n\
	JNE	1b\n\
	TST.W	r13\n\
	JNE	1b\n\
	POP	r14\n\
	POP	r13",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_delay_cycles_32 },
    &operand_data[8],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1522 */
  {
    "delay_cycles_32x",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "PUSHM.A	#2,r14\n\
	MOV.W	%A0, r13\n\
	MOV.W	%B0, r14\n\
1:	SUB.W	#1, r13\n\
	SUBC.W	#0, r14\n\
	JNE	1b\n\
	TST.W	r13\n\
	JNE	1b\n\
	POPM.A	#2,r14",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_delay_cycles_32x },
    &operand_data[8],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1538 */
  {
    "delay_cycles_16",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "PUSH	r13\n\
	MOV.W	%0, r13\n\
1:	SUB.W	#1, r13\n\
	JNE	1b\n\
	POP	r13",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_delay_cycles_16 },
    &operand_data[8],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1550 */
  {
    "delay_cycles_16x",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "PUSHM.A	#1,r13\n\
	MOV.W	%0, r13\n\
1:	SUB.W	#1, r13\n\
	JNE	1b\n\
	POPM.A	#1,r13",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_delay_cycles_16x },
    &operand_data[8],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1562 */
  {
    "delay_cycles_2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "JMP	.+2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_delay_cycles_2 },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1568 */
  {
    "delay_cycles_1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "NOP",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_delay_cycles_1 },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1615 */
  {
    "*mulhisi3_inline",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_141 },
#else
    { 0, 0, output_141 },
#endif
    { 0 },
    &operand_data[215],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1628 */
  {
    "*umulhisi3_inline",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_142 },
#else
    { 0, 0, output_142 },
#endif
    { 0 },
    &operand_data[215],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1641 */
  {
    "mulsidi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_143 },
#else
    { 0, 0, output_143 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsidi3 },
    &operand_data[218],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1654 */
  {
    "umulsidi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_144 },
#else
    { 0, 0, output_144 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umulsidi3 },
    &operand_data[218],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:246 */
  {
    "movsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi },
    &operand_data[221],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:928 */
  {
    "ashlhi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashlhi3 },
    &operand_data[223],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:928 */
  {
    "ashrhi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashrhi3 },
    &operand_data[223],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:928 */
  {
    "lshrhi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_lshrhi3 },
    &operand_data[223],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:928 */
  {
    "ashlpsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashlpsi3 },
    &operand_data[226],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:928 */
  {
    "ashrpsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashrpsi3 },
    &operand_data[226],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:928 */
  {
    "lshrpsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_lshrpsi3 },
    &operand_data[226],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:928 */
  {
    "ashlsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashlsi3 },
    &operand_data[229],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:928 */
  {
    "ashrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashrsi3 },
    &operand_data[229],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:928 */
  {
    "lshrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_lshrsi3 },
    &operand_data[229],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:928 */
  {
    "ashldi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashldi3 },
    &operand_data[232],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:928 */
  {
    "ashrdi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashrdi3 },
    &operand_data[232],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:928 */
  {
    "lshrdi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_lshrdi3 },
    &operand_data[232],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1015 */
  {
    "prologue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_prologue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1021 */
  {
    "epilogue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_epilogue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1064 */
  {
    "call",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call },
    &operand_data[235],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1078 */
  {
    "call_value",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_value },
    &operand_data[237],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1105 */
  {
    "eh_return",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_eh_return },
    &operand_data[240],
    1,
    1,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1161 */
  {
    "cbranchqi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchqi4 },
    &operand_data[241],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1161 */
  {
    "cbranchhi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchhi4 },
    &operand_data[245],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1161 */
  {
    "cbranchpsi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchpsi4 },
    &operand_data[249],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1585 */
  {
    "mulhisi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulhisi3 },
    &operand_data[215],
    3,
    3,
    0,
    1,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1600 */
  {
    "umulhisi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umulhisi3 },
    &operand_data[215],
    3,
    3,
    0,
    1,
    0
  },
};


const char *
get_insn_name (int code)
{
  if (code == NOOP_MOVE_INSN_CODE)
    return "NOOP_MOVE";
  else
    return insn_data[code].name;
}
